Package org.apache.sling.discovery

# Interface ClusterView

@ProviderType public interface ClusterView
A ClusterView represents the instances of a cluster that are up and running and that all can see each other at a certain point in time.

'Seeing each other'/A cluster refers to being hooked to the same underlying persistence layer/jcr repository.

A ClusterView can also consist of just one single instance.

All instances in a cluster must and do have a unique sling.id.

See Also:
  - `InstanceDescription.getSlingId()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getId()`
Returns a stable id of the cluster represented by this cluster view.
`List<InstanceDescription>`
`getInstances()`
Provides the list of InstanceDescriptions with a stable ordering.
`InstanceDescription`
`getLeader()`
Provides the InstanceDescription belonging to the leader instance.

## Method Details

### getId

String getId()
Returns a stable id of the cluster represented by this cluster view.

Similar to the SlingID, this id is persisted and thus remains stable accross instance/cluster restarts.

When an instance joins a cluster, it will inherit the id from the joined cluster (thus incurs a cluster id change).

Note: When instances part from a cluster (eg due to a network partitioning) the cluster id is retained. This results in potentially multiple clusters with the same id. This fact could be used to detect such partitioning/split brain situations. It also implies though that the cluster id is not guaranteed to be unique in a topology!

Addition in 1.0.4: this id must consist only of alphanumeric characters plus dash '-' and underscore '_'.

Returns:
  an id of this cluster view
Since:
  exists since 1.0.0 - stable since 1.0.2 - alphanumeric + '_' and'-' since 1.0.4
See Also:
  - SLING-3164

### getInstances

List<InstanceDescription> getInstances()
Provides the list of InstanceDescriptions with a stable ordering.

Stable ordering implies that unless an instance leaves the cluster (due to shutdown/crash/network problems) the instance keeps the relative position in the list.

Returns:
  the list of InstanceDescriptions (with a stable ordering)

### getLeader

InstanceDescription getLeader()
Provides the InstanceDescription belonging to the leader instance.

Every ClusterView is guaranteed to have one and only one leader.

The leader is stable: once a leader is elected it stays leader unless it leaves the cluster (due to shutdown/crash/network problems)

Returns:
  the InstanceDescription belonging to the leader instance